/* Fixed point math. */

#include <PalmTypes.h>

#define FIX(x) ((Int32)((x) * (double)0x10000 + .5))
#define FIX2INT(x) (((x) + 0x8000) >> 16)
#define FLOAT(i) (((double)(i)) / (double)0x10000)

extern Int32 fsin(Int32 x);
extern Int32 fcos(Int32 x);

/* 32 bit fixed point multiply without overflow. */

static inline Int32 product(Int32 x, Int32 y)
{
	register Int32 a, b, c;
	register UInt32 r, t;

	a = y;
	a &= 0xFFFF;
	b = x;
	b &= 0xFFFF;
	asm("mulu.w %2,%0" : "=d" (r) : "0" (b), "d" (a)); /* r = a * b; */
	r += 0x8000;
	r >>= 16;
	c = x >> 16;
	asm("mulu.w %2,%0" : "=d" (t) : "0" (a), "d" (c)); /* t = c * a; */
	if (x < 0) {
		t += -a << 16;
	}
	r += t;
	a = y >> 16;
	asm("mulu.w %2,%0" : "=d" (t) : "0" (b), "d" (a)); /* t = a * b; */
	if (y < 0) {
		t += -b << 16;
	}
	r += t;
	asm("mulu.w %2,%0" : "=d" (t) : "0" (a), "d" (c)); /* t = c * a; */
	r += t << 16;

	return r;
}

